<?php

if( !class_exists('PH_Estimated_Delivery_Add_Extra_Days') ){

	class PH_Estimated_Delivery_Add_Extra_Days {

		public function __construct() {

			// Add Extra Number of Days

			$this->settings_obj 	= new PH_Estimated_Delivery_Settings_Option();

			// Cart & Checkout Page
			add_filter('ph_add_extra_days_for_backordered_products_cart_page', array($this, 'ph_est_delivery_add_extra_days_cart_page'), 12, 2);
			
			// Product Page
			add_filter('ph_add_extra_days_for_backordered_products_product_page', array($this, 'ph_est_delivery_add_extra_days_product_page'), 12, 2);

			// Package Level
			add_filter('ph_add_extra_days_for_backordered_products_package', array($this, 'ph_est_delivery_add_extra_days_cart_page'), 12, 2);

		}


		public function ph_est_delivery_add_extra_days_cart_page($extra_backorder_days, $cart_items) {

			// WPML Global Object
		    global $sitepress;

			$extra_days = array();

			foreach ($cart_items as $cart_item) {

				$in_backorder 		= false;

				// Check each product's stock status to execute the Rule.
				$cart_item_stock_status 		= $cart_item['data']->get_stock_status();
				$cart_item_manage_stock 		= $cart_item['data']->get_manage_stock();
				$cart_item_product_quantity 	= $cart_item['quantity'];
				$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

				if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {

					$in_backorder = true;
				}
                
				// Check for WPML Plugin
			    if( $sitepress && ICL_LANGUAGE_CODE != null ) {

					$default_id         = isset( $cart_item['variation_id'] )  && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
				    $default_product 	= $this->ph_get_default_product_data( $default_id, $sitepress->get_default_language() );
				    if( $default_product instanceof WC_Product ) {

					    $product_id 	= $default_product->get_id();
					    $product_class  = $default_product->get_shipping_class();
			        }			       
			    } else {

					if( $cart_item['variation_id'] == 0) {

					$product_id 		= $cart_item['product_id'];
					$product_class 		= isset($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

				    }else{

					$product_id 		= $cart_item['variation_id'];
					$product_class 		= isset($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
				    }
			    }

				if( isset($this->settings_obj->settings['rule_matrix']) && $in_backorder ) {

					foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

						$product_name 		= isset( $value['product'] ) ? $value['product'] : array();
						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();

						$product_with_class 	= array_merge($product_name, $shipping_class);

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['number'][0]) && $value['format'][0] == 'num_of_days' ) {

							$extra_days[] = $value['number'][0];
						}

					}
				}
			}
			
			$extra_backorder_days += empty($extra_days) ? 0 : max($extra_days);

			return $extra_backorder_days;
		}

		public function ph_est_delivery_add_extra_days_product_page($extra_backorder_days, $product) {

			// WPML Global Object
		    global $sitepress;

			$product_name 			= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

            // Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $product->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 		= $default_product->get_id();
					$product_class      = $default_product->get_shipping_class();
					}
			}else{
					$product_id           = $product->get_id();
					$product_class        = $product->get_shipping_class();
			}

			if( isset($this->settings_obj->settings['rule_matrix'])) {

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name 		= isset( $value['product'] ) ? $value['product'] : array();
					$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();

					$product_with_class 	= array_merge($product_name, $shipping_class);

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['number'][0]) && $value['format'][0] == 'num_of_days' ) {

						$extra_backorder_days += $value['number'][0];

					}
				}
			}

			return $extra_backorder_days;
		}

		//WPML

		private function ph_get_default_product_data( $current_productid, $default_langauge, $return_productid = false ) {
		
			$default_product_id = apply_filters( 'wpml_object_id', $current_productid, 'post', true, $default_langauge ); 	// Get the Default Product Id
	
			if( $return_productid ) {
				return $default_product_id;
			}
	
			$default_product 	= wc_get_product($default_product_id); 	// Get the Default Product
	
			return $default_product;
		}

	}

	new PH_Estimated_Delivery_Add_Extra_Days();
}