<?php

if( !class_exists('PH_Estimated_Delivery_Add_Fixed_Date_or_Custom_Text') ){

	class PH_Estimated_Delivery_Add_Fixed_Date_or_Custom_Text {

		public function __construct() {

			// Fixed Date & Custom Text

			$this->settings_obj 	= new PH_Estimated_Delivery_Settings_Option();

			// Support for only Simple Text Format
			if( $this->settings_obj->page_text_format == 'simple' )
			{
				add_filter( 'xa_estimated_delivery_shop_page', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_shop_page'), 12, 1 );
				add_filter( 'xa_estimated_delivery_cart_checkout_page_html_formatted_date', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_cart_checkout_page'), 12, 2 );
				add_filter( 'woocommerce_cart_item_name', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_cart_item'), 12, 2 );
				add_filter( 'woocommerce_get_availability', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_product_page'), 50, 2 );
				add_filter( 'xa_estimated_delivery_thank_you_page_html_formatted_date', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_thankyou_page'), 12, 2 );
				add_filter( 'ph_adjust_estimated_delivery_based_on_each_item_on_thankyou_page', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_item_thankyou_page'), 12, 2 );

				// To print estimted delivery in anywhere in the product page
				add_filter('ph_estimated_delivery_anywhere_on_product_page',array($this,'ph_change_estimated_delivery_anywhere_on_product'), 12, 2);
			}
			else
			{
				add_filter( 'xa_estimated_delivery_shop_page', array($this, 'ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_shop_page_for_simple_and_date_range'), 12, 1 );
				add_filter( 'xa_estimated_delivery_cart_checkout_page_html_formatted_date', array($this, 'ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_cart_checkout_page_for_simple_and_date_range'), 12, 2 );
				add_filter( 'woocommerce_cart_item_name', array($this, 'ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_each_cart_item_for_simple_and_date_range'), 12, 2 );
				add_filter( 'woocommerce_get_availability', array($this, 'ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_product_page_for_simple_and_date_range'), 50, 2 );
				add_filter( 'xa_estimated_delivery_thank_you_page_html_formatted_date', array($this, 'ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_thankyou_page_for_simple_and_date_range'), 12, 2 );
				add_filter( 'ph_adjust_estimated_delivery_based_on_each_item_on_thankyou_page', array($this, 'ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_item_thankyou_page_for_simple_and_date_range'), 12, 2 );


				// To print estimted delivery in anywhere in the product page
				add_filter('ph_estimated_delivery_anywhere_on_product_page',array($this,'ph_change_estimated_delivery_anywhere_on_product_for_simple_and_date_range'), 12, 2);
			}
		}

		// Shop Page
		public function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_shop_page( $text ) {

			// WPML Global Object
			global $sitepress;

			$in_backorder = false;
			$product = wc_get_product();

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $product->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 	= $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
				}

				$this->settings_obj->simple_text 	= $this->ph_translate_single_string( $this->settings_obj->simple_text, 'wf_estimated_delivery', 'product_page_simple_text' );

			}else{
				$product_id     = $product->get_id();
				$product_class  = $product->get_shipping_class();
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( $in_backorder || $this->settings_obj->on_all_products == 'yes' )
			{

				if( isset($this->settings_obj->settings['rule_matrix']))
				{
					foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

						// Get Product Id from Settings
						$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

						if( !$product_has_rule ){
							
							// Get Shipping Class from Settings
							$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
						}
						
						// Merge Product Id and Shipping Class
						$product_with_class = array_merge($product_name_id, $shipping_class);

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

							$text = str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text);

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}
							
						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$text = str_replace( "[date]", $custom_text, $this->settings_obj->simple_text );

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}
						}

						// Reset the variable to check for next rule
						$product_name_id 		= array();
						$shipping_class 		= array();
						$product_with_class 	= array();
					}
				}
			}

			return $text;
		}

		// Cart and Checkout Page
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_cart_checkout_page( $text, $test ) {

			// WPML Global Object
			global $sitepress;

			$cart = WC()->cart->cart_contents;

			if( isset($cart) ) {

				$date_added 	= 0;

				foreach ($cart as $cart_item) {

					$in_backorder 		= false;
					$product_has_rule	= false;

					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

					// Check each product's stock status to execute the Rule.
					$cart_item_stock_status 		= $cart_item['data']->get_stock_status();
					$cart_item_manage_stock 		= $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity 	= $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {

						$in_backorder = true;
					}

					// Check for WPML Plugin
					if( $sitepress && ICL_LANGUAGE_CODE != null ) {

						$default_id         = isset( $cart_item['variation_id']) && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
						$default_product 	= $this->ph_get_default_product_data( $default_id , $sitepress->get_default_language() );

						if( $default_product instanceof WC_Product ) {

							$product_id 		= $default_product->get_id();
							$product_class     = $default_product->get_shipping_class();
						}

						$this->settings_obj->cart_page_text 	= $this->ph_translate_single_string( $this->settings_obj->cart_page_text, 'wf_estimated_delivery', 'cart_page_text' );

					} else {

						if( $cart_item['variation_id'] == 0) {

							$product_id 		= $cart_item['product_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

						} else {

							$product_id 		= $cart_item['variation_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
						}
					}

					if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder || $this->settings_obj->on_all_products == 'yes' ) ) {

						foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

							// Get Product Id from Settings
							$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

							if( !$product_has_rule ){

								// Get Shipping Class from Settings
								$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
							}

							// Merge Product Id and Shipping Class
							$product_with_class = array_merge($product_name_id, $shipping_class);

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

								// Check already executed date is less than current date value
								if( $date_added < strtotime($value['date'][0]) ){

									$text = '<tr class="shipping" ><th> ' . $this->settings_obj->cart_page_text . '</th><td data-title="'.$this->settings_obj->cart_page_text.'"> ' . date( $this->settings_obj->display_format, strtotime($value['date'][0]) )  . '</td></tr>';

									//Compatibility with Order Delivery Addon
									$order_delivery_date = date( $this->settings_obj->display_format, strtotime($value['date'][0]) );
								}

								// Store the executed date to check next date is Max or not
								$date_added = strtotime($value['date'][0]);

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$text = '<tr class="shipping" ><th> ' . $this->settings_obj->cart_page_text . '</th><td data-title="'.$this->settings_obj->cart_page_text.'"> ' . $custom_text . '</td></tr>';

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}
							}

							// Reset the variable to check for next rule
							$product_name_id 		= array();
							$shipping_class 		= array();
							$product_with_class 	= array();

						}
					}
				}
			}

			//Compatibilty with Order Delivery date addon
			$order_delivery_date = ( isset( $order_delivery_date ) && !empty( $order_delivery_date ) ) ? $order_delivery_date  : '';
			do_action('ph_backorder_addon_order_delivery_date',$order_delivery_date );

			return $text;
		}	

		// On Each Cart Item
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_cart_item( $product_name, $cart_item )
		{

			// WPML Global Object
			global $sitepress;

			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_id         = isset( $cart_item['variation_id'] ) && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
				$default_product 	= $this->ph_get_default_product_data( $default_id , $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 	= $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
				}

				$this->settings_obj->simple_text 	= $this->ph_translate_single_string( $this->settings_obj->simple_text, 'wf_estimated_delivery', 'product_page_simple_text' );

			} else{

				if( $cart_item['variation_id'] == 0){

					$product_id 		= $cart_item['product_id'];
					$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

				} else {

					$product_id 		= $cart_item['variation_id'];
					$product_class 		= isset($cart_item['data'])  && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
				}
			}

			$cart_item_stock_status = $cart_item['data']->get_stock_status();
			$cart_item_manage_stock = $cart_item['data']->get_manage_stock();
			$cart_item_product_quantity = $cart_item['quantity'];
			$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

			if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					$explode_text 			= '<br/><small>';

					$exploded_text_arr 		= explode( $explode_text, $product_name);
					$new_estimated_delivery = $exploded_text_arr[0];

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {	

						$est_text 				= str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text);
						$new_estimated_delivery .= $explode_text.$est_text."</small>";

						$product_name = $new_estimated_delivery;

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						$est_text 				= str_replace("[date]", $custom_text, $this->settings_obj->simple_text);
						$new_estimated_delivery .= $explode_text.$est_text."</small>";
						
						$product_name = $new_estimated_delivery;

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $product_name;
		}

		// Product Page
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_product_page( $stock_arr, $item ) {

			// WPML Global Object
			global $sitepress;

			if(is_admin())
			{
				return $stock_arr;
			}

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $item->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 		= $default_product->get_id();
					$product_class      = $default_product->get_shipping_class();
				}

				$this->settings_obj->simple_text 	= $this->ph_translate_single_string( $this->settings_obj->simple_text, 'wf_estimated_delivery', 'product_page_simple_text' );

			} else {
				$product_id           = $item->get_id();
				$product_class        = $item->get_shipping_class();
			}

			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			try{
				$product = wc_get_product($item);
			}catch(Exception $e){
				return true;
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && isset($stock_arr['availability']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					if( $this->settings_obj->plain_text_mode ) {

						$explode_text 			= chop( strip_tags($this->settings_obj->simple_text),"[date]");
						$exploded_text_arr 		= explode( $explode_text, $stock_arr['availability']);
						$new_estimated_delivery = $exploded_text_arr[0];

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

							$est_text 				= strip_tags(str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text));

							$new_estimated_delivery .= $est_text;

							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$est_text 				= strip_tags(str_replace("[date]", $custom_text, $this->settings_obj->simple_text));
							$new_estimated_delivery .= $est_text;
							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						}

					} else if( $this->settings_obj->accept_html ) {

						$explode_text 			= explode( "[date]", $this->settings_obj->simple_text);

						if( isset($explode_text[0]) && isset($explode_text[1]) ) {

							$exploded_text_arr 		= explode( $explode_text[0], $stock_arr['availability']);
							$new_estimated_delivery = $exploded_text_arr[0];

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

								$est_text 				= str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text);

								$new_estimated_delivery .= $est_text;

								$stock_arr['availability'] = $new_estimated_delivery;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$est_text 				= str_replace("[date]", $custom_text, $this->settings_obj->simple_text);
								$new_estimated_delivery .= $est_text;
								$stock_arr['availability'] = $new_estimated_delivery;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							}
						}

					} else {

						$explode_text 			= "<p class='ph_est_delivery_product_page'>";
						$exploded_text_arr 		= explode( $explode_text, $stock_arr['availability']);
						$new_estimated_delivery = $exploded_text_arr[0];

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

							$est_text 				= strip_tags(str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text));

							$new_estimated_delivery .= $explode_text.$est_text."</p>";

							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$est_text 				= strip_tags(str_replace("[date]", $custom_text, $this->settings_obj->simple_text));
							$new_estimated_delivery .= $explode_text.$est_text."</p>";
							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						}
					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $stock_arr;
		}


		// Adjustment on Thank you and My Account Page.
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_thankyou_page( $text, $test ) {

			// WPML Global Object
			global $sitepress;

			$cart 			= array();

			if( is_admin() && isset($_GET['post']) ) {

				$order_id 	= $_GET['post'];
				$order 		= wc_get_order($order_id);

				if( $order instanceof WC_Order )
				{
					$order_items = $order->get_items();

					foreach( $order_items as $order_item ) {
						$cart[] = array(
							'quantity' 	=> $order_item->get_quantity(),
							'data' 		=> $order_item->get_product(),
						);
					}
				}

			}else if( WC() !== null && WC()->cart !== null ){

				$cart = WC()->cart->cart_contents;
			}

			if( !empty($cart) ) {

				$date_added 	= 0;

				foreach ($cart as $cart_item) {

					$in_backorder 		= false;
					$product_has_rule	= false;

					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

					$cart_item_stock_status 		= $cart_item['data']->get_stock_status();
					$cart_item_manage_stock 		= $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity 	= $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
						
						$in_backorder = true;
					}

					  // Check for WPML Plugin
					if( $sitepress && ICL_LANGUAGE_CODE != null ) {

						$default_id          = isset( $cart_item['variation_id']) && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
						$default_product 	= $this->ph_get_default_product_data($default_id  , $sitepress->get_default_language() );
						if( $default_product instanceof WC_Product ) {

							$product_id 	    = $default_product->get_id();
							$product_class    = $default_product->get_shipping_class();
						}				       
					} else {

						if( $cart_item['variation_id'] == 0) {

							$product_id 		= $cart_item['product_id'];
							$product_class 	= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

						} else {

							$product_id      = $cart_item['variation_id'];
							$product_class   = isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
						}
					}

					if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) ) {
						
						foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

							$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

							if( !$product_has_rule ){

								$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
							}

							// Merge Product Id and Shipping Class
							$product_with_class = array_merge($product_name_id, $shipping_class);

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && $value['format'][0] == 'fixed_date' ) {

								// Check already executed date is less than current date value
								if( $date_added < strtotime($value['date'][0]) ) {

									$text = date( $this->settings_obj->display_format, strtotime($value['date'][0]) );
								}

								// Store the executed date to check next date is Max or not
								$date_added = strtotime($value['date'][0]);

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$text = $custom_text;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}
							}

							// Reset the variable to check for next rule
							$product_name_id 		= array();
							$shipping_class 		= array();
							$product_with_class 	= array();
						}
					}
				}
			}

			return $text;
		}

		//	Adjustment for Each Item in Thank you and My Account page.
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_item_thankyou_page( $delivery_text ,$product) {

			// WPML Global Object
			global $sitepress;

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_id        = $product->get_variation_id() == 0 ? $product->get_product_id() : $product->get_variation_id();
				try{
					$product = wc_get_product($default_id);
				}catch(Exception $e){
					return true;
				} 

				$default_product   = $this->ph_get_default_product_data( $default_id, $sitepress->get_default_language() );
				if( $default_product instanceof WC_Product ) {

					$product_id 		= $default_product->get_id();
					$product_class 	    = $default_product->get_shipping_class();
					$product_name 		= $product->get_name();;
				}

				$this->settings_obj->simple_text 	= $this->ph_translate_single_string( $this->settings_obj->simple_text, 'wf_estimated_delivery', 'product_page_simple_text' );

			} else {

				if( $product->get_variation_id() == 0){

					$product_id 	    = $product->get_product_id();
					$product_name 	    = $product->get_name();

				} else {
					$product_id 		= $product->get_variation_id();
					$product_name 		= $product->get_name();
				}

				try{
					$product = wc_get_product($product_id);
				}catch(Exception $e){
					return true;
				}

				$product_class 	        = $product->get_shipping_class(); 
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;
			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

						$delivery_text = str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text);

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						$delivery_text = str_replace("[date]", $custom_text, $this->settings_obj->simple_text);

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();
				}
			}
			return $delivery_text;
		}

		// To override the Estimated delivery date added anywhere in the Product Page
		public function ph_change_estimated_delivery_anywhere_on_product($delivery_text, $item)
		{
            // WPML Global Object
			global $sitepress;

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $item->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 		= $default_product->get_id();
					$product_class      = $default_product->get_shipping_class();
				}

				$this->settings_obj->simple_text 	= $this->ph_translate_single_string( $this->settings_obj->simple_text, 'wf_estimated_delivery', 'product_page_simple_text' );

			} else {
				$product_id     = $item->get_id();
				$product_class  = $item->get_shipping_class();
			}
			
			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			try{
				$product = wc_get_product($item);
			}catch(Exception $e){
				return true;
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && isset($delivery_text) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					$explode_text 			= chop( strip_tags($this->settings_obj->simple_text),"[date]");
					$exploded_text_arr 		= explode( $explode_text, $delivery_text);
					$new_estimated_delivery = $exploded_text_arr[0];

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

						if( !$this->settings_obj->plain_text_mode && $this->settings_obj->accept_html ) {

							$est_text 		= str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text);

							$delivery_text 	= $est_text;
							
						} else{

							$est_text 				= strip_tags(str_replace("[date]",date( $this->settings_obj->display_format, strtotime($value['date'][0]) ),$this->settings_obj->simple_text));

							$new_estimated_delivery .= $est_text;

							$delivery_text = strip_tags($new_estimated_delivery);
						}

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						if( !$this->settings_obj->plain_text_mode && $this->settings_obj->accept_html  ) {

							$est_text 		= str_replace("[date]", $custom_text, $this->settings_obj->simple_text);

							$delivery_text 	= $est_text;

						} else {

							$est_text 				= strip_tags(str_replace("[date]", $custom_text, $this->settings_obj->simple_text));

							$new_estimated_delivery .= $est_text;

							$delivery_text = strip_tags($new_estimated_delivery);
						}

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $delivery_text;
		}



		/********************************************************************************************************************/

		//for simple range and date range
		// Shop Page
		public function ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_shop_page_for_simple_and_date_range( $text ) {

			// WPML Global Object
			global $sitepress;

			$in_backorder = false;
			$product = wc_get_product();

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $product->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 		= $default_product->get_id();
					$product_class      = $default_product->get_shipping_class();
				}

				$this->settings_obj->range_text 	= $this->ph_translate_single_string( $this->settings_obj->range_text, 'wf_estimated_delivery', 'product_page_range_text' );

			} else {
				$product_id           = $product->get_id();
				$product_class        = $product->get_shipping_class();
			}
			
			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( $in_backorder || $this->settings_obj->on_all_products == 'yes' )
			{

				if( isset($this->settings_obj->settings['rule_matrix']))
				{
					foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

						// Get Product Id from Settings
						$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

						if( !$product_has_rule ){
							
							// Get Shipping Class from Settings
							$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
						}
						
						// Merge Product Id and Shipping Class
						$product_with_class = array_merge($product_name_id, $shipping_class);

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

							$explode_text= explode('[date_1]',$this->settings_obj->range_text);

							if(isset($explode_text[0]))
							{
								$text=$explode_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;
							}
							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}
							
						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$text = $custom_text;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}
						}

						// Reset the variable to check for next rule
						$product_name_id 		= array();
						$shipping_class 		= array();
						$product_with_class 	= array();
					}
				}
			}

			return $text;
		}

         // Cart and Checkout Page
		function ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_cart_checkout_page_for_simple_and_date_range( $text, $test ) {

            // WPML Global Object
			global $sitepress;

			$cart 			= WC()->cart->cart_contents;

			if( isset($cart) ) {

				$date_added 	= 0;

				foreach ($cart as $cart_item) {

					$in_backorder 		= false;
					$product_has_rule	= false;

					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

					// Check each product's stock status to execute the Rule.
					$cart_item_stock_status 		= $cart_item['data']->get_stock_status();
					$cart_item_manage_stock 		= $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity 	= $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {

						$in_backorder = true;
					}

					// Check for WPML Plugin
					if( $sitepress && ICL_LANGUAGE_CODE != null ) {

						$default_id         = isset( $cart_item['variation_id'] ) && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
						$default_product 	= $this->ph_get_default_product_data( $default_id , $sitepress->get_default_language() );

						if( $default_product instanceof WC_Product ) {

							$product_id 		= $default_product->get_id();
							$product_class    = $default_product->get_shipping_class();
						}

						$this->settings_obj->cart_page_text 	= $this->ph_translate_single_string( $this->settings_obj->cart_page_text, 'wf_estimated_delivery', 'cart_page_text' );

					} else {

						if( $cart_item['variation_id'] == 0) {

							$product_id 		= $cart_item['product_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

						} else{

							$product_id 		= $cart_item['variation_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
						}
					}

					if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder || $this->settings_obj->on_all_products == 'yes' ) ) {

						foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

							// Get Product Id from Settings
							$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

							if( !$product_has_rule ){

								// Get Shipping Class from Settings
								$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
							}

							// Merge Product Id and Shipping Class
							$product_with_class = array_merge($product_name_id, $shipping_class);

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

								// Check already executed date is less than current date value
								if( $date_added < strtotime($value['date'][0]) ){

									$text = '<tr class="shipping" ><th> ' . $this->settings_obj->cart_page_text . '</th><td data-title="'.$this->settings_obj->cart_page_text.'"> ' . date( $this->settings_obj->display_format, strtotime($value['date'][0]) )  . '</td></tr>';

									//Compatibility with Order Delivery addon
									$order_delivery_date = date( $this->settings_obj->display_format, strtotime($value['date'][0]) );
								}

								// Store the executed date to check next date is Max or not
								$date_added = strtotime($value['date'][0]);

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$text = '<tr class="shipping" ><th> ' . $this->settings_obj->cart_page_text . '</th><td data-title="'.$this->settings_obj->cart_page_text.'"> ' . $custom_text . '</td></tr>';

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}
							}

							// Reset the variable to check for next rule
							$product_name_id 		= array();
							$shipping_class 		= array();
							$product_with_class 	= array();

						}
					}
				}
			}

			//Compatibilty with Order Delivery date addon
			$order_delivery_date = ( isset( $order_delivery_date ) && !empty( $order_delivery_date ) ) ? $order_delivery_date  : '';
			do_action('ph_backorder_addon_order_delivery_date',$order_delivery_date );

			return $text;
		}


       // On Each Cart Item
		function ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_each_cart_item_for_simple_and_date_range( $product_name, $cart_item )
		{
            // WPML Global Object
			global $sitepress;

			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_id         = isset( $cart_item['variation_id'] )  && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
				$default_product 	= $this->ph_get_default_product_data( $default_id, $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 	= $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
				}

				$this->settings_obj->range_text 	= $this->ph_translate_single_string( $this->settings_obj->range_text, 'wf_estimated_delivery', 'product_page_range_text' );

			} else {

				if( $cart_item['variation_id'] == 0){

					$product_id 		= $cart_item['product_id'];
					$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

				}else {

					$product_id 		= $cart_item['variation_id'];
					$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
				}
			}

			$cart_item_stock_status = $cart_item['data']->get_stock_status();
			$cart_item_manage_stock = $cart_item['data']->get_manage_stock();
			$cart_item_product_quantity = $cart_item['quantity'];
			$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

			if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					$explode_text 			= '<br/><small>';

					$exploded_text_arr 		= explode( $explode_text, $product_name);
					$new_estimated_delivery = $exploded_text_arr[0];

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {	

						$explod_text= explode('[date_1]',$this->settings_obj->range_text);

						$est_text=$explod_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) );
						

						
						$new_estimated_delivery .= $explode_text.$est_text."</small>";

						$product_name = $new_estimated_delivery;

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						$est_text 				= $custom_text;
						$new_estimated_delivery .= $explode_text.$est_text."</small>";

						
						$product_name = $new_estimated_delivery;

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $product_name;
		}


             // Product Page
		function ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_product_page_for_simple_and_date_range( $stock_arr, $item ) {

			// WPML Global Object
			global $sitepress;

			if(is_admin())
			{
				return $stock_arr;
			}

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $item->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 	= $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
				}

				$this->settings_obj->range_text 	= $this->ph_translate_single_string( $this->settings_obj->range_text, 'wf_estimated_delivery', 'product_page_range_text' );

			} else {
				$product_id     = $item->get_id();
				$product_class  = $item->get_shipping_class();
			}

			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			try{
				$product = wc_get_product($item);
			}catch(Exception $e){
				return true;
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && isset($stock_arr['availability']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					if( $this->settings_obj->plain_text_mode ) {

						$explode_text 			= explode( "[date_1]", strip_tags($this->settings_obj->range_text));
						$exploded_text_arr 		= explode( $explode_text[0], $stock_arr['availability']);
						$new_estimated_delivery = $exploded_text_arr[0];



						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

							$est_text=$explode_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;

							$new_estimated_delivery .= $est_text;


							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$est_text 				= $custom_text;
							$new_estimated_delivery .= $est_text;
							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						}

					} else if( $this->settings_obj->accept_html ) {

						$explode_text 			= explode( "[date_1]", $this->settings_obj->range_text);

						if( isset($explode_text[0]) && isset($explode_text[1]) ) {

							$exploded_text_arr 		= explode( $explode_text[0], $stock_arr['availability']);
							$new_estimated_delivery = $exploded_text_arr[0];

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

								$est_text=$explode_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;

								$new_estimated_delivery .= $est_text;

								$stock_arr['availability'] = $new_estimated_delivery;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$est_text 				= $custom_text;
								$new_estimated_delivery .= $est_text;
								$stock_arr['availability'] = $new_estimated_delivery;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							}
						}

					} else {

						$explode_text 			= "<p class='ph_est_delivery_product_page'>";
						
						$exploded_text_arr 		= explode( $explode_text, $stock_arr['availability']);

						$new_estimated_delivery = $exploded_text_arr[0];

						if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

							$explod_text 			= explode( "[date_1]", $this->settings_obj->range_text);

							
							$est_text=$explod_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;


							$new_estimated_delivery .= $explode_text.$est_text."</p>";

							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

							$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

							$est_text 				= $custom_text;
							$new_estimated_delivery .= $explode_text.$est_text."</p>";
							$stock_arr['availability'] = $new_estimated_delivery;

							// If Product rule is already executed, dont check for shipping class rule
							if( !empty($product_name_id) )
							{
								$product_has_rule = true;
							}

						}
					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $stock_arr;
		}

		// Adjustment on Thank you and My Account Page.
		function ph_add_fixed_date_and_custom_text_estimated_delivery_based_on_backorder_on_thankyou_page_for_simple_and_date_range( $text, $test ) {

			// WPML Global Object
			global $sitepress;

			$cart 			= array();

			if( is_admin() && isset($_GET['post']) ) {

				$order_id 	= $_GET['post'];
				$order 		= wc_get_order($order_id);

				if( $order instanceof WC_Order )
				{
					$order_items = $order->get_items();

					foreach( $order_items as $order_item ) {
						$cart[] = array(
							'quantity' 	=> $order_item->get_quantity(),
							'data' 		=> $order_item->get_product(),
						);
					}
				}

			}else if( WC() !== null && WC()->cart !== null ){

				$cart = WC()->cart->cart_contents;
			}

			if( !empty($cart) ) {

				$date_added 	= 0;

				foreach ($cart as $cart_item) {

					$in_backorder 		= false;
					$product_has_rule	= false;

					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

					$cart_item_stock_status 		= $cart_item['data']->get_stock_status();
					$cart_item_manage_stock 		= $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity 	= $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
						
						$in_backorder = true;
					}

					// Check for WPML Plugin
					if( $sitepress && ICL_LANGUAGE_CODE != null ) {

						$default_id         =  isset( $cart_item['variation_id'] ) && $cart_item['variation_id'] == 0 ? $cart_item['product_id'] : $cart_item['variation_id'];
						$default_product 	= $this->ph_get_default_product_data( $default_id, $sitepress->get_default_language() );
						if( $default_product instanceof WC_Product ) {

							$product_id 		= $default_product->get_id();
							$product_class    = $default_product->get_shipping_class();
						}
					} else {

						if( $cart_item['variation_id'] == 0) {

							$product_id 		    = $cart_item['product_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';

						} else {

							$product_id = $cart_item['variation_id'];
							$product_class 		= isset($cart_item['data']) && !empty($cart_item['data']) ? $cart_item['data']->get_shipping_class() : '';
						}
					}

					if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) ) {
						
						foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

							$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

							if( !$product_has_rule ){

								$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
							}

							// Merge Product Id and Shipping Class
							$product_with_class = array_merge($product_name_id, $shipping_class);

							if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && $value['format'][0] == 'fixed_date' ) {

								// Check already executed date is less than current date value
								if( $date_added < strtotime($value['date'][0]) ) {

									$text = date( $this->settings_obj->display_format, strtotime($value['date'][0]) );
								}

								// Store the executed date to check next date is Max or not
								$date_added = strtotime($value['date'][0]);

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}

							} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

								$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

								$text = $custom_text;

								// If Product rule is already executed, dont check for shipping class rule
								if( !empty($product_name_id) )
								{
									$product_has_rule = true;
								}
							}

							// Reset the variable to check for next rule
							$product_name_id 		= array();
							$shipping_class 		= array();
							$product_with_class 	= array();
						}
					}
				}
			}

			return $text;
		}

		//	Adjustment for Each Item in Thank you and My Account page.
		function ph_add_fixed_date_estimated_delivery_based_on_backorder_on_each_item_thankyou_page_for_simple_and_date_range( $delivery_text ,$product) {

			// WPML Global Object
			global $sitepress;

			if( $sitepress && ICL_LANGUAGE_CODE != null ) {


				$default_id         = $product->get_variation_id() == 0 ? $product->get_product_id() : $product->get_variation_id();

				try{
					$product = wc_get_product($default_id);
				}catch(Exception $e){
					return true;
				}

				$default_product 	= $this->ph_get_default_product_data( $default_id, $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id 	= $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
					$product_name   = $product->get_name();
				}

				$this->settings_obj->range_text 	= $this->ph_translate_single_string( $this->settings_obj->range_text, 'wf_estimated_delivery', 'product_page_range_text' );

			} else {

				if( $product->get_variation_id() == 0){

					$product_id 		= $product->get_product_id();
					$product_name 	    = $product->get_name();

				} else{
					$product_id 		= $product->get_variation_id();
					$product_name 		= $product->get_name();
				}

				try{
					$product = wc_get_product($product_id);
				}catch(Exception $e){
					return true;
				}

				$product_class 		    = $product->get_shipping_class();

			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;
			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' ) {

						$explode_text= explode('[date_1]',$this->settings_obj->range_text);

						if(isset($explode_text[0]))
						{
							$delivery_text=$explode_text[0].date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;
						}
						
						
						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						$delivery_text = $custom_text;

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();
				}
			}
			return $delivery_text;
		}

		// To override the Estimated delivery date added anywhere in the Product Page
		public function ph_change_estimated_delivery_anywhere_on_product_for_simple_and_date_range($delivery_text, $item)
		{
			// WPML Global Object
			global $sitepress;

			// Check for WPML Plugin
			if( $sitepress && ICL_LANGUAGE_CODE != null ) {

				$default_product 	= $this->ph_get_default_product_data( $item->get_id(), $sitepress->get_default_language() );

				if( $default_product instanceof WC_Product ) {

					$product_id     = $default_product->get_id();
					$product_class  = $default_product->get_shipping_class();
				}

				$this->settings_obj->range_text 	= $this->ph_translate_single_string( $this->settings_obj->range_text, 'wf_estimated_delivery', 'product_page_range_text' );
			} else {
				$product_id     = $item->get_id();
				$product_class  = $item->get_shipping_class();
			}

			$in_backorder 			= false;
			$product_has_rule		= false;

			$product_name_id 		= array();
			$shipping_class 		= array();
			$product_with_class 	= array();

			try{
				$product = wc_get_product($item);
			}catch(Exception $e){
				return true;
			}

			$product_stock_status 	= $product->get_stock_status();
			$product_manage_stock   = $product->get_manage_stock();
			$product_name 			= $product->get_name();
			$cart 					= WC()->cart->cart_contents;
			$product_quantity 		= 1;

			if( isset($cart) ){
				foreach( $cart as $cart_item ) {
					if( $product_name === $cart_item['data']->get_name() ){	
						$product_quantity 		= $cart_item['quantity'];
					}
				}
			}

			$product_backorder_status 	= $product->is_on_backorder($product_quantity);

			if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
				$in_backorder = true;
			}

			if( isset($this->settings_obj->settings['rule_matrix']) && isset($delivery_text) && ( $in_backorder ||  $this->settings_obj->on_all_products == 'yes' ) )
			{

				foreach ($this->settings_obj->settings['rule_matrix'] as $key => $value) {

					$product_name_id 		= isset( $value['product'] ) ? $value['product'] : array();

					if( !$product_has_rule ){

						$shipping_class 	= isset( $value['shipping_class'] ) ? $value['shipping_class'] : array();
					}

					// Merge Product Id and Shipping Class
					$product_with_class = array_merge($product_name_id, $shipping_class);

					
					$exploded_text_arr 		= explode('[date_1]', strip_tags($this->settings_obj->range_text));
					$new_estimated_delivery = $exploded_text_arr[0];

					if( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['date'][0]) && $value['format'][0] == 'fixed_date' && !empty($exploded_text_arr[1]) ) {

						if( !$this->settings_obj->plain_text_mode && $this->settings_obj->accept_html ) {

							$est_text=$new_estimated_delivery .date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;

							$delivery_text 	= $est_text;
							
						} else{

							$est_text 		= $new_estimated_delivery .date( $this->settings_obj->display_format, strtotime($value['date'][0]) ) ;

							$delivery_text = strip_tags($est_text);
						}

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					} elseif ( ( in_array($product_id, $product_with_class) || in_array($product_class, $product_with_class) ) && isset($value['range'][0]) && $value['format'][0] == 'fixed_range' && !empty($exploded_text_arr[1]) ) {

						$custom_text 	= $this->ph_translate_single_string( $value['range'][0], 'ph_estimated_delivery_backorder_addon', 'ph_backorder_product_custom_text' );

						if( !$this->settings_obj->plain_text_mode && $this->settings_obj->accept_html  ) {

							$est_text 		= $custom_text;

							$delivery_text 	= $est_text;

						} else {

							$est_text 		= $custom_text;

							$delivery_text 	= strip_tags($est_text);
						}

						// If Product rule is already executed, dont check for shipping class rule
						if( !empty($product_name_id) )
						{
							$product_has_rule = true;
						}

					}

					// Reset the variable to check for next rule
					$product_name_id 		= array();
					$shipping_class 		= array();
					$product_with_class 	= array();

				}
			}

			return $delivery_text;
		}

		// WPML Compatibility
		private function ph_get_default_product_data( $current_productid, $default_langauge, $return_productid = false ) {

			$default_product_id = apply_filters( 'wpml_object_id', $current_productid, 'post', true, $default_langauge ); 	// Get the Default Product Id

			if( $return_productid ) {
				return $default_product_id;
			}

			$default_product 	= wc_get_product($default_product_id); 	// Get the Default Product

			return $default_product;
		}

		// WPML Compatibility
		private function ph_translate_single_string( $string, $domain, $name ) {

			do_action( 'wpml_register_single_string', $domain, $name, $string );

			$string = apply_filters( 'wpml_translate_single_string', $string, $domain, $name );

			return $string;
		}

	}

	new PH_Estimated_Delivery_Add_Fixed_Date_or_Custom_Text();
}