<?php

if( !class_exists('PH_Estimated_Delivery_Skip_Calculation') ){

	class PH_Estimated_Delivery_Skip_Calculation {

		public function __construct() {

			// Skip Product From Est. Date Calculation

			$this->settings_obj 	= new PH_Estimated_Delivery_Settings_Option();

			add_filter( 'ph_skip_estimated_delivery_of_given_product', array($this, 'ph_skip_est_delivery_of_given_product'), 12, 2);
			add_filter( 'ph_skip_estimated_delivery_extra_days_calculation', array($this, 'ph_skip_est_delivery_from_extra_calculation'), 12, 2);
			add_filter( 'xa_estimated_delivery_cart_checkout_page_html_formatted_date', array($this, 'ph_skip_from_cart_checkout_page'), 12, 2);
			add_filter( 'xa_estimated_delivery_thank_you_page_html_formatted_date', array($this, 'ph_skip_from_thank_you_page'), 12, 2);

		}

		public function ph_skip_est_delivery_of_given_product($status, $product)
		{
			if( $this->settings_obj->restrict_nonbackorder == 'yes'){

				try{
					$product = wc_get_product($product);
				}catch(Exception $e){
					return true;
				}

				$product_stock_status 	= $product->get_stock_status();
				$product_manage_stock   = $product->get_manage_stock();
				$product_name 			= $product->get_name();
				$cart 					= WC()->cart->cart_contents;
				$product_quantity 		= 1;

				if( isset($cart) ){
					foreach( $cart as $cart_item ) {
						if( $product_name === $cart_item['data']->get_name() ){	
							$product_quantity 		= $cart_item['quantity'];
						}
					}
				}

				$product_backorder_status 	= $product->is_on_backorder($product_quantity);

				if( ( in_array( $product_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$product_manage_stock ) || ( $product_backorder_status && $product_manage_stock ) ) {
					return false;
				}
				return true;
			}else{
				return false;
			}
		}

		public function ph_skip_est_delivery_from_extra_calculation($status, $cart_items)
		{
			if( $this->settings_obj->restrict_nonbackorder == 'yes'){

				foreach ($cart_items as $cart_item) {

					$cart_item_stock_status = $cart_item['data']->get_stock_status();
					$cart_item_manage_stock = $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity = $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
						return false;
					}
				}
				return true;
			}else{
				return false;
			}
		}

		public function ph_skip_from_cart_checkout_page($text, $test)
		{
			if( $this->settings_obj->restrict_nonbackorder == 'yes')
			{
				$cart 		= WC()->cart->cart_contents;
				$cart_backorder = false;
				foreach( $cart as $cart_item ) {

					$cart_item_stock_status = $cart_item['data']->get_stock_status();
					$cart_item_manage_stock = $cart_item['data']->get_manage_stock();
					$cart_item_product_quantity = $cart_item['quantity'];
					$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

					if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
						$cart_backorder = true;
					}
				}

				if( $cart_backorder == false && $test == 0)
				{
					$text = null;
				}

				return $text;
			}else{
				return $text;
			}

		}

		public function ph_skip_from_thank_you_page($text, $test)
		{
			if( $this->settings_obj->restrict_nonbackorder == 'yes')
			{

				$cart_backorder = false;
				$cart 			= array();

				if( is_admin() && isset($_GET['post']) ) {

					$order_id = $_GET['post'];
					$order = wc_get_order($order_id);

					if( $order instanceof WC_Order )
					{
						$order_items = $order->get_items();

						foreach( $order_items as $order_item ) {
							$cart[] = array(
								'quantity' 	=> $order_item->get_quantity(),
								'data'		=> $order_item->get_product(),
							);
						}
					}
				}else if( WC() !== null && WC()->cart !== null ){

					$cart = WC()->cart->cart_contents;
				}

				if( !empty($cart) ){
					foreach( $cart as $cart_item ) {

						$cart_item_stock_status = $cart_item['data']->get_stock_status();
						$cart_item_manage_stock = $cart_item['data']->get_manage_stock();
						$cart_item_product_quantity = $cart_item['quantity'];
						$cart_item_product_backorder_status 	= $cart_item['data']->is_on_backorder($cart_item_product_quantity);

						if( (in_array($cart_item_stock_status, Ph_Estimated_Delivery_Backorder_Addon::$stock_status_arr) && !$cart_item_manage_stock ) || ( $cart_item_product_backorder_status && $cart_item_manage_stock ) ) {
							$cart_backorder = true;
						}
					}
				}

				if( $cart_backorder == false && $test == 0)
				{
					$text = null;
					if( is_admin() ){
						$text = 'No Estimated Delivery';
					}
				}

				return $text;
			}else{
				return $text;
			}

		}

	}

	new PH_Estimated_Delivery_Skip_Calculation();
}